Subject: Implement a central command line controller
Description

Currently FLOW3 provides a command line interface through the flow3.sh bash script which has a fixed support for certain
commands. This logic of this script should be extracted and improved so that we'll end up with very lean flow3.sh and flow3.bat scripts
which just pass the command line arguments to a FLOW3CLI.php script.

The FLOW3CLI should allow for simple registration of additional commands so that third party packages can also take advantage of
the interface. In the long run this script could also provide an interactive shell which allows for executing the available commands.

Related issues:
related to TYPO3.Flow - Feature # 4426: Provide Windows compatible version of... Resolved
related to TYPO3.Flow - Bug # 3463: Short option names for CLI calls do not w... Closed 2009-05-25
related to TYPO3.Flow - Feature # 6681: Make the php cli executable configura... Resolved 2010-03-03
related to TYPO3.Flow - Feature # 7216: Custom CLI Controller without Modific... Closed 2010-04-12

History
#1 - 2009-09-07 22:27 - Bastian Waidelich

I've started playing around with a new FLOW3 subpackage "CLI". It could provide a simple API to allow interaction with the command line like 
output(), outputLine(), prompt($message), registerCommand(Command $command), outputHelp()...

A "Command" knows about its allowed/required arguments and is associated with a package, controller & action. With those information the CLI script
would be able to display some auto generated help- and input screen for all registered commands.

FLOW3s main CLI script (e.g. FLOW3CLI.php) could make use of these classes and provide "hooks" for other packages to register their commands.
But people could also write their own CLI scripts and make use of the "CLI helper". This is rather rough, but what do you think about it generally? Gotta
play with it a bit more..

Regarding the interaction. Can someone please try, whether this works on Mac/Unix:

$stdin = fopen('php://stdin','r');
$input = fread($stdin, 1024);
echo 'you\'ve entered "' . $input . '"';

#2 - 2009-09-08 10:09 - Robert Lemke

Bastian Waidelich wrote:

Regarding the interaction. Can someone please try, whether this works on Mac/Unix:
[...]

yes, that works on my Mac (and it should work on Linux as well)

#3 - 2010-01-20 11:06 - Karsten Dambekalns
- Target version set to 1.0 alpha 8

#4 - 2010-01-28 17:18 - Karsten Dambekalns
- Assigned To set to Bastian Waidelich

#5 - 2010-01-28 17:18 - Karsten Dambekalns
- Status changed from New to Accepted

#6 - 2010-03-06 12:34 - Karsten Dambekalns
- Target version changed from 1.0 alpha 8 to 1.0 alpha 9

#7 - 2010-05-28 17:38 - Robert Lemke
- Target version deleted (1.0 alpha 9)

#8 - 2011-06-28 12:34 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- Target version set to 1.0 beta 1
- % Done changed from 0 to 100

Resolved with commit:d44501c
